<template>
  <dialog-card
    :title="$t('dialogs.add-piece.title')"
    :actions="actions"
  >
    <v-form
      ref="form"
      v-model="valid"
    >
      <!-- name -->
      <v-text-field
        v-model="name"
        :rules="[
          v => (!!v && v.length > 0) || $t('dialogs.add-piece.error.required'),
        ]"
        :label="$t('dialogs.add-piece.label.name')"
        required
      />
      <!-- email -->
      <v-text-field
        v-model="email"
        :rules="[
          v => (!!v && v.length > 0) || $t('dialogs.add-piece.error.required'),
          v => /.+@.+\..+/.test(v) || $t('dialogs.add-piece.error.email'),
        ]"
        :label="$t('dialogs.add-piece.label.email')"
        required
      />
      <!-- title -->
      <v-text-field
        v-model="title"
        :rules="[
          v => (!!v && v.length > 0) || $t('dialogs.add-piece.error.required'),
        ]"
        :label="$t('dialogs.add-piece.label.title')"
        required
      />
      <!-- Composer or artist -->
      <v-text-field
        v-model="composerOrArtist"
        :rules="[
          v => (!!v && v.length > 0) || $t('dialogs.add-piece.error.required'),
        ]"
        :label="$t('dialogs.add-piece.label.composerOrArtist')"
        required
      />

      <i18n path="dialogs.add-piece.label.formats.text" tag="p">
        {{ $t('dialogs.add-piece.label.formats.text') }}
      </i18n>

      <!-- score, MEI -->
      <file-or-url-input
        v-model="musicFileOrUrl" :label="$t('dialogs.add-piece.label.musicFile')"
      />
      <!-- audio -->
      <file-or-url-input
        v-model="audioFileOrUrl" :label="$t('dialogs.add-piece.label.audioFile')"
      />

      <div class="d-flex">
        <v-checkbox
          v-model="acceptedConditions"
          class="mt-0"
          :rules="[
            v => (!!v && v === true),
          ]"
          required
        />
        <i18n path="dialogs.add-piece.label.conditions.text" tag="p">
          <template #link>
            <a
              href="http://algomus.fr/privacy"
              rel="noopener noreferrer"
              target="_blank"
            >
              {{ $t('dialogs.add-piece.label.conditions.pp') }}
            </a>
          </template>
        </i18n>
      </div>
    </v-form>
  </dialog-card>
</template>

<script lang="ts">
import type { Client } from '@/client';
import { ClientStatus } from '@/client';
import {
  Component, Prop, Vue,
} from 'vue-property-decorator';
import FileOrUrlInput from '@/components/inputs/FileOrUrlInput.vue';

@Component({
  components: {
    FileOrUrlInput,
  },
})
export default class AddPieceDialog extends Vue {
  @Prop({ required: true })
  client!: Client;

  name = '';

  email = '';

  title = '';

  composerOrArtist = '';

  mei = '';

  mp3 = '';

  valid = false;

  musicFileOrUrl: string | File | null = null;

  audioFileOrUrl: string | File | null = null;

  acceptedConditions = false;

  success = false;

  mounted() {
    if (this.client.user?.name) {
      this.name = this.client.user.name;
    }
  }

  get actions() {
    return {
      cancel: {
        text: this.$t('dialogs.add-piece.action.cancel'),
        handle: this.close,
      },
      export: {
        text: this.$t('dialogs.add-piece.action.submit'),
        handle: this.upload,
        disabled: !this.valid,
      },
    };
  }

  async upload() {
    // eslint-disable-next-line @typescript-eslint/no-explicit-any
    (this.$refs.form as unknown as any).validate();
    // Upload Piece
    try {
      this.success = false;
      let queryString = `?name=${this.name}&email=${this.email}`;
      if (typeof this.musicFileOrUrl === 'string') {
        queryString += `&score_url=${this.musicFileOrUrl}`;
      }
      if (typeof this.audioFileOrUrl === 'string') {
        queryString += `&audio_url=${this.audioFileOrUrl}`;
      }

      const formData = new FormData();

      const infos = {
        title: this.title,
        composer: this.composerOrArtist,
        email: this.email,
      };
      formData.append('infos', new Blob([JSON.stringify(infos)]));

      if (typeof this.musicFileOrUrl !== 'string' && this.musicFileOrUrl) {
        formData.append('score', this.musicFileOrUrl);
      }

      if (typeof this.audioFileOrUrl !== 'string' && this.audioFileOrUrl) {
        formData.append('audio', this.audioFileOrUrl);
      }

      const resp = await this.client.post(`${process.env.VUE_APP_CORPUS_URL}addNewPiece/${this.name.replaceAll(' ', '-')}/${this.title.replaceAll(' ', '-')}${queryString}`, formData, {
        timeout: 600 * 1000,
      });

      if (resp.status === ClientStatus.NoResponse) {
        this.$dialog.notify.error(this.$t('dialogs.add-piece.info.error').toString(), {
          position: 'top-center',
          timeout: 0,
          dismissible: true,
        });
      } else {
        this.$dialog.notify.success(this.$t('dialogs.add-piece.info.info').toString(), {
          position: 'top-center',
          timeout: 0,
          dismissible: true,
        });
        this.success = true;
      }
    } catch (error) {
      this.success = false;
    }
  }

  close() {
    this.$emit('submit', false);
  }
}
</script>
